<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/aho-corasick-0.7.18/src/packed/rabinkarp.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>rabinkarp.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../aho_corasick/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../aho_corasick/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../aho_corasick/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::mem</span>;

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::packed::pattern</span>::{<span class="ident">PatternID</span>, <span class="ident">Patterns</span>};
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::Match</span>;

<span class="doccomment">/// The type of the rolling hash used in the Rabin-Karp algorithm.</span>
<span class="kw">type</span> <span class="ident">Hash</span> <span class="op">=</span> <span class="ident">usize</span>;

<span class="doccomment">/// The number of buckets to store our patterns in. We don&#39;t want this to be</span>
<span class="doccomment">/// too big in order to avoid wasting memory, but we don&#39;t want it to be too</span>
<span class="doccomment">/// small either to avoid spending too much time confirming literals.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The number of buckets MUST be a power of two. Otherwise, determining the</span>
<span class="doccomment">/// bucket from a hash will slow down the code considerably. Using a power</span>
<span class="doccomment">/// of two means `hash % NUM_BUCKETS` can compile down to a simple `and`</span>
<span class="doccomment">/// instruction.</span>
<span class="kw">const</span> <span class="ident">NUM_BUCKETS</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">64</span>;

<span class="doccomment">/// An implementation of the Rabin-Karp algorithm. The main idea of this</span>
<span class="doccomment">/// algorithm is to maintain a rolling hash as it moves through the input, and</span>
<span class="doccomment">/// then check whether that hash corresponds to the same hash for any of the</span>
<span class="doccomment">/// patterns we&#39;re looking for.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// A draw back of naively scaling Rabin-Karp to multiple patterns is that</span>
<span class="doccomment">/// it requires all of the patterns to be the same length, which in turn</span>
<span class="doccomment">/// corresponds to the number of bytes to hash. We adapt this to work for</span>
<span class="doccomment">/// multiple patterns of varying size by fixing the number of bytes to hash</span>
<span class="doccomment">/// to be the length of the smallest pattern. We also split the patterns into</span>
<span class="doccomment">/// several buckets to hopefully make the confirmation step faster.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Wikipedia has a decent explanation, if a bit heavy on the theory:</span>
<span class="doccomment">/// https://en.wikipedia.org/wiki/Rabin%E2%80%93Karp_algorithm</span>
<span class="doccomment">///</span>
<span class="doccomment">/// But ESMAJ provides something a bit more concrete:</span>
<span class="doccomment">/// http://www-igm.univ-mlv.fr/~lecroq/string/node5.html</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">RabinKarp</span> {
    <span class="doccomment">/// The order of patterns in each bucket is significant. Namely, they are</span>
    <span class="doccomment">/// arranged such that the first one to match is the correct match. This</span>
    <span class="doccomment">/// may not necessarily correspond to the order provided by the caller.</span>
    <span class="doccomment">/// For example, if leftmost-longest semantics are used, then the patterns</span>
    <span class="doccomment">/// are sorted by their length in descending order. If leftmost-first</span>
    <span class="doccomment">/// semantics are used, then the patterns are sorted by their pattern ID</span>
    <span class="doccomment">/// in ascending order (which corresponds to the caller&#39;s order).</span>
    <span class="ident">buckets</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span>(<span class="ident">Hash</span>, <span class="ident">PatternID</span>)<span class="op">&gt;</span><span class="op">&gt;</span>,
    <span class="doccomment">/// The length of the hashing window. Generally, this corresponds to the</span>
    <span class="doccomment">/// length of the smallest pattern.</span>
    <span class="ident">hash_len</span>: <span class="ident">usize</span>,
    <span class="doccomment">/// The factor to subtract out of a hash before updating it with a new</span>
    <span class="doccomment">/// byte.</span>
    <span class="ident">hash_2pow</span>: <span class="ident">usize</span>,
    <span class="doccomment">/// The maximum identifier of a pattern. This is used as a sanity check</span>
    <span class="doccomment">/// to ensure that the patterns provided by the caller are the same as</span>
    <span class="doccomment">/// the patterns that were used to compile the matcher. This sanity check</span>
    <span class="doccomment">/// possibly permits safely eliminating bounds checks regardless of what</span>
    <span class="doccomment">/// patterns are provided by the caller.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// (Currently, we don&#39;t use this to elide bounds checks since it doesn&#39;t</span>
    <span class="doccomment">/// result in a measurable performance improvement, but we do use it for</span>
    <span class="doccomment">/// better failure modes.)</span>
    <span class="ident">max_pattern_id</span>: <span class="ident">PatternID</span>,
}

<span class="kw">impl</span> <span class="ident">RabinKarp</span> {
    <span class="doccomment">/// Compile a new Rabin-Karp matcher from the patterns given.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This panics if any of the patterns in the collection are empty, or if</span>
    <span class="doccomment">/// the collection is itself empty.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">patterns</span>: <span class="kw-2">&amp;</span><span class="ident">Patterns</span>) -&gt; <span class="ident">RabinKarp</span> {
        <span class="macro">assert!</span>(<span class="ident">patterns</span>.<span class="ident">len</span>() <span class="op">&gt;</span><span class="op">=</span> <span class="number">1</span>);
        <span class="kw">let</span> <span class="ident">hash_len</span> <span class="op">=</span> <span class="ident">patterns</span>.<span class="ident">minimum_len</span>();
        <span class="macro">assert!</span>(<span class="ident">hash_len</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">1</span>);

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">hash_2pow</span> <span class="op">=</span> <span class="number">1usize</span>;
        <span class="kw">for</span> <span class="kw">_</span> <span class="kw">in</span> <span class="number">1</span>..<span class="ident">hash_len</span> {
            <span class="ident">hash_2pow</span> <span class="op">=</span> <span class="ident">hash_2pow</span>.<span class="ident">wrapping_shl</span>(<span class="number">1</span>);
        }

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">rk</span> <span class="op">=</span> <span class="ident">RabinKarp</span> {
            <span class="ident">buckets</span>: <span class="macro">vec!</span>[<span class="macro">vec!</span>[]; <span class="ident">NUM_BUCKETS</span>],
            <span class="ident">hash_len</span>,
            <span class="ident">hash_2pow</span>,
            <span class="ident">max_pattern_id</span>: <span class="ident">patterns</span>.<span class="ident">max_pattern_id</span>(),
        };
        <span class="kw">for</span> (<span class="ident">id</span>, <span class="ident">pat</span>) <span class="kw">in</span> <span class="ident">patterns</span>.<span class="ident">iter</span>() {
            <span class="kw">let</span> <span class="ident">hash</span> <span class="op">=</span> <span class="ident">rk</span>.<span class="ident">hash</span>(<span class="kw-2">&amp;</span><span class="ident">pat</span>.<span class="ident">bytes</span>()[..<span class="ident">rk</span>.<span class="ident">hash_len</span>]);
            <span class="kw">let</span> <span class="ident">bucket</span> <span class="op">=</span> <span class="ident">hash</span> <span class="op">%</span> <span class="ident">NUM_BUCKETS</span>;
            <span class="ident">rk</span>.<span class="ident">buckets</span>[<span class="ident">bucket</span>].<span class="ident">push</span>((<span class="ident">hash</span>, <span class="ident">id</span>));
        }
        <span class="ident">rk</span>
    }

    <span class="doccomment">/// Return the first matching pattern in the given haystack, begining the</span>
    <span class="doccomment">/// search at `at`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">find_at</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">patterns</span>: <span class="kw-2">&amp;</span><span class="ident">Patterns</span>,
        <span class="ident">haystack</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
        <span class="kw-2">mut</span> <span class="ident">at</span>: <span class="ident">usize</span>,
    ) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Match</span><span class="op">&gt;</span> {
        <span class="macro">assert_eq!</span>(<span class="ident">NUM_BUCKETS</span>, <span class="self">self</span>.<span class="ident">buckets</span>.<span class="ident">len</span>());
        <span class="macro">assert_eq!</span>(
            <span class="self">self</span>.<span class="ident">max_pattern_id</span>,
            <span class="ident">patterns</span>.<span class="ident">max_pattern_id</span>(),
            <span class="string">&quot;Rabin-Karp must be called with same patterns it was built with&quot;</span>,
        );

        <span class="kw">if</span> <span class="ident">at</span> <span class="op">+</span> <span class="self">self</span>.<span class="ident">hash_len</span> <span class="op">&gt;</span> <span class="ident">haystack</span>.<span class="ident">len</span>() {
            <span class="kw">return</span> <span class="prelude-val">None</span>;
        }
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">hash</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">hash</span>(<span class="kw-2">&amp;</span><span class="ident">haystack</span>[<span class="ident">at</span>..<span class="ident">at</span> <span class="op">+</span> <span class="self">self</span>.<span class="ident">hash_len</span>]);
        <span class="kw">loop</span> {
            <span class="kw">let</span> <span class="ident">bucket</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">buckets</span>[<span class="ident">hash</span> <span class="op">%</span> <span class="ident">NUM_BUCKETS</span>];
            <span class="kw">for</span> <span class="kw-2">&amp;</span>(<span class="ident">phash</span>, <span class="ident">pid</span>) <span class="kw">in</span> <span class="ident">bucket</span> {
                <span class="kw">if</span> <span class="ident">phash</span> <span class="op">==</span> <span class="ident">hash</span> {
                    <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">c</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">verify</span>(<span class="ident">patterns</span>, <span class="ident">pid</span>, <span class="ident">haystack</span>, <span class="ident">at</span>) {
                        <span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">c</span>);
                    }
                }
            }
            <span class="kw">if</span> <span class="ident">at</span> <span class="op">+</span> <span class="self">self</span>.<span class="ident">hash_len</span> <span class="op">&gt;</span><span class="op">=</span> <span class="ident">haystack</span>.<span class="ident">len</span>() {
                <span class="kw">return</span> <span class="prelude-val">None</span>;
            }
            <span class="ident">hash</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">update_hash</span>(
                <span class="ident">hash</span>,
                <span class="ident">haystack</span>[<span class="ident">at</span>],
                <span class="ident">haystack</span>[<span class="ident">at</span> <span class="op">+</span> <span class="self">self</span>.<span class="ident">hash_len</span>],
            );
            <span class="ident">at</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
        }
    }

    <span class="doccomment">/// Returns the approximate total amount of heap used by this searcher, in</span>
    <span class="doccomment">/// units of bytes.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">heap_bytes</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="kw">let</span> <span class="ident">num_patterns</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">max_pattern_id</span> <span class="kw">as</span> <span class="ident">usize</span> <span class="op">+</span> <span class="number">1</span>;
        <span class="self">self</span>.<span class="ident">buckets</span>.<span class="ident">len</span>() <span class="op">*</span> <span class="ident">mem::size_of</span>::<span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span>(<span class="ident">Hash</span>, <span class="ident">PatternID</span>)<span class="op">&gt;</span><span class="op">&gt;</span>()
            <span class="op">+</span> <span class="ident">num_patterns</span> <span class="op">*</span> <span class="ident">mem::size_of</span>::<span class="op">&lt;</span>(<span class="ident">Hash</span>, <span class="ident">PatternID</span>)<span class="op">&gt;</span>()
    }

    <span class="doccomment">/// Verify whether the pattern with the given id matches at</span>
    <span class="doccomment">/// `haystack[at..]`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// We tag this function as `cold` because it helps improve codegen.</span>
    <span class="doccomment">/// Intuitively, it would seem like inlining it would be better. However,</span>
    <span class="doccomment">/// the only time this is called and a match is not found is when there</span>
    <span class="doccomment">/// there is a hash collision, or when a prefix of a pattern matches but</span>
    <span class="doccomment">/// the entire pattern doesn&#39;t match. This is hopefully fairly rare, and</span>
    <span class="doccomment">/// if it does occur a lot, it&#39;s going to be slow no matter what we do.</span>
    <span class="attribute">#[<span class="ident">cold</span>]</span>
    <span class="kw">fn</span> <span class="ident">verify</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">patterns</span>: <span class="kw-2">&amp;</span><span class="ident">Patterns</span>,
        <span class="ident">id</span>: <span class="ident">PatternID</span>,
        <span class="ident">haystack</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
        <span class="ident">at</span>: <span class="ident">usize</span>,
    ) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Match</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">pat</span> <span class="op">=</span> <span class="ident">patterns</span>.<span class="ident">get</span>(<span class="ident">id</span>);
        <span class="kw">if</span> <span class="ident">pat</span>.<span class="ident">is_prefix</span>(<span class="kw-2">&amp;</span><span class="ident">haystack</span>[<span class="ident">at</span>..]) {
            <span class="prelude-val">Some</span>(<span class="ident">Match::from_span</span>(<span class="ident">id</span> <span class="kw">as</span> <span class="ident">usize</span>, <span class="ident">at</span>, <span class="ident">at</span> <span class="op">+</span> <span class="ident">pat</span>.<span class="ident">len</span>()))
        } <span class="kw">else</span> {
            <span class="prelude-val">None</span>
        }
    }

    <span class="doccomment">/// Hash the given bytes.</span>
    <span class="kw">fn</span> <span class="ident">hash</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">bytes</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="ident">Hash</span> {
        <span class="macro">assert_eq!</span>(<span class="self">self</span>.<span class="ident">hash_len</span>, <span class="ident">bytes</span>.<span class="ident">len</span>());

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">hash</span> <span class="op">=</span> <span class="number">0usize</span>;
        <span class="kw">for</span> <span class="kw-2">&amp;</span><span class="ident">b</span> <span class="kw">in</span> <span class="ident">bytes</span> {
            <span class="ident">hash</span> <span class="op">=</span> <span class="ident">hash</span>.<span class="ident">wrapping_shl</span>(<span class="number">1</span>).<span class="ident">wrapping_add</span>(<span class="ident">b</span> <span class="kw">as</span> <span class="ident">usize</span>);
        }
        <span class="ident">hash</span>
    }

    <span class="doccomment">/// Update the hash given based on removing `old_byte` at the beginning</span>
    <span class="doccomment">/// of some byte string, and appending `new_byte` to the end of that same</span>
    <span class="doccomment">/// byte string.</span>
    <span class="kw">fn</span> <span class="ident">update_hash</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">prev</span>: <span class="ident">Hash</span>, <span class="ident">old_byte</span>: <span class="ident">u8</span>, <span class="ident">new_byte</span>: <span class="ident">u8</span>) -&gt; <span class="ident">Hash</span> {
        <span class="ident">prev</span>.<span class="ident">wrapping_sub</span>((<span class="ident">old_byte</span> <span class="kw">as</span> <span class="ident">usize</span>).<span class="ident">wrapping_mul</span>(<span class="self">self</span>.<span class="ident">hash_2pow</span>))
            .<span class="ident">wrapping_shl</span>(<span class="number">1</span>)
            .<span class="ident">wrapping_add</span>(<span class="ident">new_byte</span> <span class="kw">as</span> <span class="ident">usize</span>)
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="aho_corasick" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>